﻿using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using System.Windows.Navigation;
using System.Windows.Threading;
using System.Windows;
using System;
using Microsoft.Xna.Framework;

namespace Checkers
{

    public class XNAAsyncDispatcher : IApplicationService // added to enable sound
    {
        private DispatcherTimer frameworkDispatcherTimer;

        public XNAAsyncDispatcher(TimeSpan dispatchInterval)
        {
            this.frameworkDispatcherTimer = new DispatcherTimer();
            this.frameworkDispatcherTimer.Tick += new EventHandler(frameworkDispatcherTimer_Tick);
            this.frameworkDispatcherTimer.Interval = dispatchInterval;
        }

        void IApplicationService.StartService(ApplicationServiceContext context) { this.frameworkDispatcherTimer.Start(); }
        void IApplicationService.StopService() { this.frameworkDispatcherTimer.Stop(); }
        void frameworkDispatcherTimer_Tick(object sender, EventArgs e) { FrameworkDispatcher.Update(); }
    }

    public partial class App : Application
    {
        /// <summary>
        /// Provides easy access to the root frame of the Phone Application.
        /// </summary>
        /// <returns>The root frame of the Phone Application.</returns>
        public PhoneApplicationFrame RootFrame { get; private set; }

        /// <summary>
        /// Constructor for the Application object.
        /// </summary>

        private void AdExceptionHandler(object sender, ApplicationUnhandledExceptionEventArgs e)
        {
            if (System.Diagnostics.Debugger.IsAttached)
            { // An unhandled exception has occurred, break in the debugger System.Diagnostics.Debugger.Break(); } e.Handled = true; 
                System.Diagnostics.Debugger.Break();
                e.Handled = true;
                return;
            }

            if (e.ExceptionObject is MyAdException)
            {// Source: http://www.thewindowsclub.com/wp7-tutorial-6-managing-errors-in-the-application#ixzz1EKX9aVjE
                //System.Diagnostics.Debugger.Break(); 
                e.Handled = true;
                return;
            }
        }

        public App()
        {
            UnhandledException += AdExceptionHandler; //myeventhandler

            // Global handler for uncaught exceptions. 
            UnhandledException += Application_UnhandledException;

            // Show graphics profiling information while debugging.
            if (System.Diagnostics.Debugger.IsAttached)
            {
                // Display the current frame rate counters.
                Application.Current.Host.Settings.EnableFrameRateCounter = true;

                // Show the areas of the app that are being redrawn in each frame.
                //Application.Current.Host.Settings.EnableRedrawRegions = true;

            }

            // Standard Silverlight initialization
            InitializeComponent();

            // Phone-specific initialization
            InitializePhoneApplication();

            // initialize sounds DEBUG
            this.ApplicationLifetimeObjects.Add(new XNAAsyncDispatcher(TimeSpan.FromMilliseconds(50)));

        }

        // Code to execute when the application is launching (eg, from Start)
        // This code will not execute when the application is reactivated
        private void Application_Launching(object sender, LaunchingEventArgs e)
        {
        }

        // Code to execute when the application is activated (brought to foreground)
        // This code will not execute when the application is first launched
        private void Application_Activated(object sender, ActivatedEventArgs e)
        {
            /*
            StoredSettings s = new StoredSettings();
            s.AddOrUpdateValue("ComingFromTombstone", 1);
            s.Save();
             * */
        }

        // Code to execute when the application is deactivated (sent to background)
        // This code will not execute when the application is closing
        private void Application_Deactivated(object sender, DeactivatedEventArgs e)
        {
            //int i;
            //ISS s = new ISS();
            /*
            s.AddOrUpdateValue("NextTurnWhiteOrBlack", T.nextturnwhiteorblack);
            s.AddOrUpdateValue("BoardState", T.boardstate);
            s.AddOrUpdateValue("HistorySaved", T.HistorySaved);
             * */

            /*
             * NEED TO FIX THIS!
            if (T.t_MainBoard_boardmovenumber <= 4)
                s.AddOrUpdateValue("ComingFromTombstone", 0);
            else
                s.AddOrUpdateValue("ComingFromTombstone", 1);
             * */

            /*
            if (T.HistorySaved > 0)
            {
                for (i = 0; i < T.HistorySaved; i++)
                {
             * */
                    /*
                    s.AddOrUpdateValue((String.Concat("BP", i.ToString())), T.BoardHistory[i].BlackPiecesBoard);
                    s.AddOrUpdateValue((String.Concat("WP", i.ToString())), T.BoardHistory[i].WhitePiecesBoard);
                    s.AddOrUpdateValue((String.Concat("BK", i.ToString())), T.BoardHistory[i].BlackKingPiecesBoard);
                    s.AddOrUpdateValue((String.Concat("WK", i.ToString())), T.BoardHistory[i].WhiteKingPiecesBoard);
                    s.AddOrUpdateValue((String.Concat("PC", i.ToString())), T.BoardHistoryColor[i]);
                     * */
            /*
                }
            }
            s.Save();
            s = null;
             * */
        }


        // Code to execute when the application is closing (eg, user hit Back)
        // This code will not execute when the application is deactivated
        private void Application_Closing(object sender, ClosingEventArgs e)
        {
        }

        // Code to execute if a navigation fails
        private void RootFrame_NavigationFailed(object sender, NavigationFailedEventArgs e)
        {
            if (System.Diagnostics.Debugger.IsAttached)
            {
                // A navigation has failed; break into the debugger
                System.Diagnostics.Debugger.Break();
            }
        }

        // Code to execute on Unhandled Exceptions
        private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
        {
            if (System.Diagnostics.Debugger.IsAttached)
            {
                // An unhandled exception has occurred; break into the debugger
                System.Diagnostics.Debugger.Break();
            }
        }

        #region Phone application initialization

        // Avoid double-initialization
        private bool phoneApplicationInitialized = false;

        // Do not add any additional code to this method
        private void InitializePhoneApplication()
        {
            if (phoneApplicationInitialized)
                return;

            // Create the frame but don't set it as RootVisual yet; this allows the splash
            // screen to remain active until the application is ready to render.
            RootFrame = new PhoneApplicationFrame();
            RootFrame.Navigated += CompleteInitializePhoneApplication;

            // Handle navigation failures
            RootFrame.NavigationFailed += RootFrame_NavigationFailed;

            // Ensure we don't initialize again
            phoneApplicationInitialized = true;
        }

        // Do not add any additional code to this method
        private void CompleteInitializePhoneApplication(object sender, NavigationEventArgs e)
        {
            // Set the root visual to allow the application to render
            if (RootVisual != RootFrame)
                RootVisual = RootFrame;

            // Remove this handler since it is no longer needed
            RootFrame.Navigated -= CompleteInitializePhoneApplication;
        }

        #endregion
    }
}